// NEW ENGLAND - modified to a mediterranean style map by RF_Gandalf

// A Random Map for Age of Empires III: The Third One
include "mercenaries.xs";
// Main entry point for random map script
void main(void)
{
   // Text
   rmSetStatusText("",0.01);

   //Chooses which natives appear on the map
   int subCiv0=-1;
   int subCiv1=-1;
   int subCiv2=-1;
   int subCiv3=-1;

	int whichNative=rmRandInt(1,4);
	if ( whichNative > 2 )
	{
		subCiv0=rmGetCivID("Iroquois");
		rmEchoInfo("subCiv0 is Iroquois "+subCiv0);

		subCiv1=rmGetCivID("Iroquois");
		rmEchoInfo("subCiv1 is Iroquois "+subCiv1);

	      subCiv2=rmGetCivID("Cherokee");
	      rmEchoInfo("subCiv2 is Cherokee "+subCiv2);

	}
	else
	{
		subCiv0=rmGetCivID("Cherokee");
		rmEchoInfo("subCiv0 is Cherokee "+subCiv0);

		subCiv1=rmGetCivID("Cherokee");
		rmEchoInfo("subCiv1 is Cherokee "+subCiv1);

		subCiv2=rmGetCivID("Iroquois");
		rmEchoInfo("subCiv2 is Iroquois "+subCiv2);

	}

	rmSetSubCiv(0, "Cherokee", true);
	rmSetSubCiv(1, "Iroquois", true);
	rmSetSubCiv(2, "Cree", true);

   // Picks the map size
	int playerTiles=15500;
   if (cNumberNonGaiaPlayers >4)
	playerTiles = 11500;
   if (cNumberNonGaiaPlayers >6)
      playerTiles = 10500;

   // Picks default terrain and water
   rmSetSeaType("new england coast");
   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);

	// Some map turbulence...
	rmSetMapElevationParameters(cElevTurbulence, 0.4, 5, 0.7, 5.0);  
	rmSetMapElevationHeightBlend(1);

   // Picks a default water height
   rmSetSeaLevel(5.0);
   rmEnableLocalWater(false);
   rmTerrainInitialize("newengland_grass", 5.0);
	rmSetMapType("newEngland");
	rmSetMapType("land");
	rmSetWorldCircleConstraint(true);
	rmSetWindMagnitude(2.0);
	rmSetLightingSet("new england");
	rmSetMapType("grass");

	// Choose mercs.
	chooseMercs();

   // Define some classes. These are used later for constraints.
   int classPlayer=rmDefineClass("player");
   int classPlayerCore=rmDefineClass("player core");
   rmDefineClass("center");
   rmDefineClass("classCliff");
   rmDefineClass("classPatch");
   rmDefineClass("classWall");
   rmDefineClass("corner");
   rmDefineClass("starting settlement");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("importantItem");
   rmDefineClass("secrets");
   rmDefineClass("socketClass");
   rmDefineClass("nuggets");

   // Text
   rmSetStatusText("",0.10);

   // -------------Define constraints
   // These are used to have objects and areas avoid each other
   
   // Map edge constraints
   int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
   int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
   int longPlayerConstraint=rmCreateClassDistanceConstraint("stays away from players", classPlayer, 16.0);

   // Player constraints
   int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
   int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);

   // Center constraint.
   int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 25.0);
   int wideCenterConstraint=rmCreateClassDistanceConstraint("elevation avoids center", rmClassID("center"), 50.0);

   // Resource avoidance
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
   int avoidDeer=rmCreateTypeDistanceConstraint("food avoids food", "deer", 45.0);
   int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 30.0);
   int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35);
   int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 35.0);
   int avoidNuggetSmall=rmCreateTypeDistanceConstraint("nugget avoid nugget small", "AbstractNugget", 10.0);

   // Avoid impassable land
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
	int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 30.0);
	int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	int wallConstraint=rmCreateClassDistanceConstraint("wall vs. wall", rmClassID("classWall"), 40.0);
	int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 40.0);

   // Specify true so constraint stays outside of circle (i.e. inside corners)
   int cornerConstraint0=rmCreateCornerConstraint("in corner 0", 0, true);
   int cornerConstraint1=rmCreateCornerConstraint("in corner 1", 1, true);
   int cornerConstraint2=rmCreateCornerConstraint("in corner 2", 2, true);
   int cornerConstraint3=rmCreateCornerConstraint("in corner 3", 3, true);

   // Unit avoidance
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
   int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

   // ships vs. ships
   int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);

   // Decoration avoidance
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

   // VP avoidance
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
   int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 30.0);
   int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 10.0);

   // Constraint to avoid water.
   int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
   int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 10.0);
   int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water 15", "Land", false, 15.0);
   int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
   int avoidWater30 = rmCreateTerrainDistanceConstraint("avoid water mid-long", "Land", false, 30.0);
   int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);

   // New extra stuff for water spawn point avoidance.
   int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
   int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
   int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-20, 0, 0, 0);

   int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

   int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);

   // Text
   rmSetStatusText("",0.20);

   // Create a center water area -- the mediterranean part.
   int centerID=rmCreateArea("center");
   rmSetAreaSize(centerID, 0.15, 0.15);
   rmSetAreaLocation(centerID, 0.5, 0.5);
   rmSetAreaWaterType(centerID, "new england coast");
   rmAddAreaToClass(centerID, rmClassID("center"));
   rmSetAreaBaseHeight(centerID, 0.0);
   rmSetAreaMinBlobs(centerID, 7);
   rmSetAreaMaxBlobs(centerID, 10);
   rmSetAreaMinBlobDistance(centerID, 10);
   rmSetAreaMaxBlobDistance(centerID, 20);
   rmSetAreaSmoothDistance(centerID, 35);
   rmSetAreaCoherence(centerID, 0.6);
   rmBuildArea(centerID); 

   // Text
   rmSetStatusText("",0.30);

   // Placement of players.
   int placeChance=rmRandFloat(0, 1);
   if (placeChance<0.5)
   {
      rmSetPlacementTeam(0);
      rmSetPlacementSection(0.10, 0.30);
      rmPlacePlayersCircular(0.4, 0.43, rmDegreesToRadians(5.0));

      rmSetPlacementTeam(1);
      rmSetPlacementSection(0.60, 0.80);
      rmPlacePlayersCircular(0.4, 0.43, rmDegreesToRadians(5.0));
   }
   else
   {
      rmSetPlacementTeam(0);
      rmSetPlacementSection(0.72, 0.98);
      rmPlacePlayersCircular(0.4, 0.43, rmDegreesToRadians(5.0));

      rmSetPlacementTeam(1);
      rmSetPlacementSection(0.22, 0.48);
      rmPlacePlayersCircular(0.4, 0.43, rmDegreesToRadians(5.0));
   }

    // Set up player areas.
   float playerFraction=rmAreaTilesToFraction(1200);
   for(i=1; <cNumberPlayers)
   {
      // Create the area.
      int id=rmCreateArea("Player"+i);
      // Assign to the player.
      rmSetPlayerArea(i, id);
      // Set the size.
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 3);
      rmSetAreaMaxBlobs(id, 4);
      rmSetAreaMinBlobDistance(id, 30.0);
      rmSetAreaMaxBlobDistance(id, 50.0);
      rmSetAreaSmoothDistance(id, 20);
      rmAddAreaConstraint(id, playerConstraint); 
      // rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmSetAreaLocPlayer(id, i);
	rmSetAreaMix(id, "newengland_grass");
      rmSetAreaWarnFailure(id, false);
   }

   // Build the areas.
   rmBuildAllAreas();

   // center island
   int monkeyIslandID=rmCreateArea("monkeyisland");
   rmSetAreaSize(monkeyIslandID, rmAreaTilesToFraction(700), rmAreaTilesToFraction(700));
   rmSetAreaLocation(monkeyIslandID, 0.5, 0.5);
   rmSetAreaTerrainType(monkeyIslandID, "new_england\ground1_ne");
   rmSetAreaMix(monkeyIslandID, "newengland_grass");

 //  rmSetAreaMix(monkeyIslandID, "newengland_grass");
 //  rmSetAreaTerrainType(monkeyIslandID, "");
   rmSetAreaBaseHeight(monkeyIslandID, 2.0);
   rmSetAreaSmoothDistance(monkeyIslandID, 10);
   rmSetAreaHeightBlend(monkeyIslandID, 2);
   rmSetAreaCoherence(monkeyIslandID, 1.0);
   rmBuildArea(monkeyIslandID);

   // Text
   rmSetStatusText("",0.4);

   // Placement order
   // Trade route -> Lakes -> Natives -> Secrets -> Cliffs -> Nuggets

   // TRADE ROUTES

	int tradeRouteID = rmCreateTradeRoute();
	// rmAddTradeRouteWaypoint(tradeRouteID, 0.1, 0.9);
	// rmAddTradeRouteWaypoint(tradeRouteID, 0.4, 0.6);
	// rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 0.4);
	
	rmAddTradeRouteWaypoint(tradeRouteID, 0.65, 1.0);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.77, 0.69);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.79, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.77, 0.31);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.65, 0.0);
	// rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.8, 1.0, 8, 8);

	bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");

	if(placedTradeRoute == false)
		rmEchoError("Failed to place trade route #1");

	// float tradeRouteLoc2 = rmRandFloat(0,1);
	int tradeRouteID2 = rmCreateTradeRoute();
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.35, 0.0);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.23, 0.31);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.21, 0.5);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.23, 0.69);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.35, 1.0);
	
	bool placedTradeRoute2 = rmBuildTradeRoute(tradeRouteID2, "carolinas\trade_route");
	if(placedTradeRoute2 == false)
		rmEchoError("Failed to place trade route #2");

   // Trade sockets
   int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
   rmSetObjectDefAllowOverlap(socketID, true);
   rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
   rmSetObjectDefMinDistance(socketID, 0.0);
   rmSetObjectDefMaxDistance(socketID, 6.0);
   rmAddObjectDefConstraint(socketID, avoidWater15);

   // add the meeting poles along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
   vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.22);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.72);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID2);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.22);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.72);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   // Text
   rmSetStatusText("",0.50);

   // NATIVE AMERICANS

   int iroquoisVillageAID = -1;
   int iroquoisVillageType = rmRandInt(1,3);
   if ( whichNative > 2 )
   {
		iroquoisVillageAID = rmCreateGrouping("iroquois village A", "native iroquois village "+iroquoisVillageType);
   }
   else
   {
	   	iroquoisVillageAID = rmCreateGrouping("cherokee village A", "native cherokee village "+iroquoisVillageType);
   }
   rmSetGroupingMinDistance(iroquoisVillageAID, 0.0);
   rmSetGroupingMaxDistance(iroquoisVillageAID, rmXFractionToMeters(0.05));
   rmAddGroupingConstraint(iroquoisVillageAID, avoidImpassableLand);
   rmAddGroupingToClass(iroquoisVillageAID, rmClassID("importantItem"));
   rmAddGroupingConstraint(iroquoisVillageAID, avoidTradeRoute);
   rmPlaceGroupingAtLoc(iroquoisVillageAID, 0, 0.5, 0.14); 

/*
	if ( vpLocation < 3 )
	{
		rmPlaceGroupingAtLoc(iroquoisVillageAID, 0, 0.35, 0.8); // used to be 0.3 DAL
	}
	else if ( vpLocation == 3 )
	{
		rmPlaceGroupingAtLoc(iroquoisVillageAID, 0, 0.2, 0.6);
	}
	else
	{
		rmPlaceGroupingAtLoc(iroquoisVillageAID, 0, 0.8, 0.6);
	}
*/
	
	int iroquoisVillageBID = -1;
	iroquoisVillageType = rmRandInt(1,3);
	if ( whichNative > 2 )
	{
		iroquoisVillageBID = rmCreateGrouping("iroquois village B", "native iroquois village "+iroquoisVillageType);
	}
	else
	{
		iroquoisVillageBID = rmCreateGrouping("cherokee village B", "native cherokee village "+iroquoisVillageType);
	}
	rmSetGroupingMinDistance(iroquoisVillageBID, 0.0);
	rmSetGroupingMaxDistance(iroquoisVillageBID, rmXFractionToMeters(0.05));
	rmAddGroupingConstraint(iroquoisVillageBID, avoidImpassableLand);
	rmAddGroupingToClass(iroquoisVillageBID, rmClassID("importantItem"));
	rmAddGroupingConstraint(iroquoisVillageBID, avoidTradeRoute);
      rmPlaceGroupingAtLoc(iroquoisVillageBID, 0, 0.5, 0.86);

	int iroquoisVillageCID = -1;
	iroquoisVillageType = rmRandInt(1,3);
	if ( whichNative < 3 )
	{
		iroquoisVillageCID = rmCreateGrouping("iroquois village C", "native iroquois village "+iroquoisVillageType);
	}
	else
	{
		iroquoisVillageCID = rmCreateGrouping("cherokee village C", "native cherokee village "+iroquoisVillageType);
	}
	rmSetGroupingMinDistance(iroquoisVillageCID, 0.0);
	rmSetGroupingMaxDistance(iroquoisVillageCID, rmXFractionToMeters(0.05));
	rmAddGroupingConstraint(iroquoisVillageCID, avoidImpassableLand);
	rmAddGroupingToClass(iroquoisVillageCID, rmClassID("importantItem"));
	rmAddGroupingConstraint(iroquoisVillageCID, avoidTradeRoute);
      rmPlaceGroupingAtLoc(iroquoisVillageCID, 0, 0.5, 0.5); 
 
   // Starting Unit placement
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	rmSetObjectDefMinDistance(startingUnits, 5.0);
	rmSetObjectDefMaxDistance(startingUnits, 12.0);
	rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	rmAddGroupingToClass(startingUnits, rmClassID("importantItem"));

	rmAddObjectDefConstraint(startingUnits, avoidAll);
      rmAddObjectDefConstraint(startingUnits, avoidSocket);
      rmAddObjectDefConstraint(startingUnits, avoidTradeRoute);

	int startingTCID= rmCreateObjectDef("startingTC");
	if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));

	int silverType = -1;
	int playerGoldID = -1;

	int StartAreaTreeID=rmCreateObjectDef("starting trees");
	rmAddObjectDefItem(StartAreaTreeID, "TreeNewEngland", 1, 0.0);
	rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	int StartBerryBushID=rmCreateObjectDef("starting BerryBush");
	rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 5.0);
	rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	rmSetObjectDefMaxDistance(StartBerryBushID, 15.0);
	rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);

	int playerNuggetID=rmCreateObjectDef("player nugget");
	rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
      rmSetObjectDefMinDistance(playerNuggetID, 30.0);
      rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	// rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	int waterFlagID=-1;
	
	for(i=1; <cNumberPlayers)
	{
		rmClearClosestPointConstraints();
		// Place starting units and a TC!
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Everyone gets one ore grouping close by.
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddGroupingToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Placing starting Pronghorns...
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// Placing starting trees...
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Nuggets
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Water flag
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
	//	rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
            vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		rmClearClosestPointConstraints();

	}

   // Cliffs

		int bigCliff1ID=rmCreateArea("big cliff 1");
	   rmSetAreaSize(bigCliff1ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(650));
		rmSetAreaWarnFailure(bigCliff1ID, false);
		rmSetAreaCliffType(bigCliff1ID, "New England");
		rmAddAreaToClass(bigCliff1ID, rmClassID("classCliff"));  
		rmSetAreaCliffEdge(bigCliff1ID, 1, 0.6, 0.1, 1.0, 0);  // Number of edges, second is size of each edge, third is variance
		rmSetAreaCliffPainting(bigCliff1ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(bigCliff1ID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(bigCliff1ID, 1.0);
//	rmAddAreaTerrainLayer(bigCliff1ID, "new_england\ground4_ne", 0, 2);
		rmSetAreaMinBlobs(bigCliff1ID, 3);
		rmSetAreaMaxBlobs(bigCliff1ID, 5);
		rmSetAreaMinBlobDistance(bigCliff1ID, 12.0);
		rmSetAreaMaxBlobDistance(bigCliff1ID, 25.0);
		rmSetAreaSmoothDistance(bigCliff1ID, 15);
		rmSetAreaCoherence(bigCliff1ID, 0.4);
		rmAddAreaConstraint(bigCliff1ID, avoidImportantItem);
		rmAddAreaConstraint(bigCliff1ID, avoidTradeRoute);
	      rmAddAreaConstraint(bigCliff1ID, centerConstraint);
	      rmAddAreaConstraint(bigCliff1ID, avoidWater20);
	      rmAddAreaConstraint(bigCliff1ID, avoidCliffs);
	      rmAddAreaConstraint(bigCliff1ID, avoidSocket);
	      rmAddAreaConstraint(bigCliff1ID, edgeConstraint);
	      rmAddAreaConstraint(bigCliff1ID, avoidStartingUnits);
	      rmAddAreaConstraint(bigCliff1ID, longPlayerConstraint);		
		rmAddAreaInfluenceSegment(bigCliff1ID, 0.4, 0.52, 0.35, 0.68);
		rmBuildArea(bigCliff1ID);

   int numCliffs = rmRandInt(3,4);
   for (i=0; <numCliffs)
   {    
		int bigCliff2ID=rmCreateArea("big cliff 2" +i);
	      rmSetAreaSize(bigCliff2ID, rmAreaTilesToFraction(400), rmAreaTilesToFraction(500));
		rmSetAreaWarnFailure(bigCliff2ID, false);
		rmSetAreaCliffType(bigCliff2ID, "New England");
		rmAddAreaToClass(bigCliff2ID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(bigCliff2ID, 1, 0.5, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(bigCliff2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(bigCliff2ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(bigCliff2ID, 1.0);
//	rmAddAreaTerrainLayer(bigCliff2ID, "new_england\ground4_ne", 0, 1);
		rmSetAreaMinBlobs(bigCliff2ID, 3);
		rmSetAreaMaxBlobs(bigCliff2ID, 5);
		rmSetAreaMinBlobDistance(bigCliff2ID, 12.0);
		rmSetAreaMaxBlobDistance(bigCliff2ID, 20.0);
		rmSetAreaSmoothDistance(bigCliff2ID, 15);
		rmSetAreaCoherence(bigCliff2ID, 0.4);
	      rmAddAreaConstraint(bigCliff2ID, centerConstraint);
		rmAddAreaConstraint(bigCliff2ID, avoidImportantItem);
		rmAddAreaConstraint(bigCliff2ID, avoidTradeRoute);
	      rmAddAreaConstraint(bigCliff2ID, avoidWater20);
	      rmAddAreaConstraint(bigCliff2ID, avoidCliffs);
	      rmAddAreaConstraint(bigCliff2ID, avoidSocket);
	      rmAddAreaConstraint(bigCliff2ID, edgeConstraint);
	      rmAddAreaConstraint(bigCliff2ID, avoidStartingUnits);
	      rmAddAreaConstraint(bigCliff2ID, longPlayerConstraint);
		rmAddAreaInfluenceSegment(bigCliff2ID, 0.6, 0.52, 0.65, 0.68);
		rmBuildArea(bigCliff2ID);
   }

	// Text
   rmSetStatusText("",0.60);

   // Define and place Nuggets
	int nuggetID= rmCreateObjectDef("nugget"); 
	rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	rmSetObjectDefMinDistance(nuggetID, 0.0);
	rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(nuggetID, shortAvoidImpassableLand);
  	rmAddObjectDefConstraint(nuggetID, avoidNugget);
	rmAddObjectDefConstraint(nuggetID, avoidStartingUnits);
  	rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
	rmAddObjectDefConstraint(nuggetID, avoidSocket);
  	rmAddObjectDefConstraint(nuggetID, avoidAll);
  	rmAddObjectDefConstraint(nuggetID, avoidWater10);
	rmAddObjectDefConstraint(nuggetID, circleConstraint);
	rmAddObjectDefConstraint(nuggetID, centerConstraint);
	rmSetNuggetDifficulty(2, 3);
      rmPlaceObjectDefPerPlayer(nuggetID, false, 5); 

   // fish
   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 25.0);
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
   int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 33.0);

   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, "FishCod", 2, 5.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*7);

   // FAST COIN -- WHALES
   int whaleID=rmCreateObjectDef("whale");
   rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
   rmSetObjectDefMinDistance(whaleID, 0.0);
   rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
   rmAddObjectDefConstraint(whaleID, whaleLand);
   rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);

   // Text
   rmSetStatusText("",0.65); 
 
   // Place resources that we want forests to avoid
	// Fast Coin
	int silverID = -1;
	int silverCount = cNumberNonGaiaPlayers*3;	// 3 per player, plus starting one.
	rmEchoInfo("silver count = "+silverCount);

	for(i=0; < silverCount)
	{
		silverType = rmRandInt(1,10);
		silverID = rmCreateObjectDef("silver "+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));

		rmAddObjectDefConstraint(silverID, avoidFastCoin);
		rmAddObjectDefConstraint(silverID, avoidCoin);
		rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidSocket);
		rmAddObjectDefConstraint(silverID, avoidStartingUnits);
		// Keep silver away from the water, to avoid the art problem with the "cliffs."
		rmAddObjectDefConstraint(silverID, avoidWater15);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }

   // FORESTS
   int forestTreeID = 0;
   int numTries=10*cNumberNonGaiaPlayers;
   int failCount=0;

   for (i=0; <numTries)
   {   
      int forest=rmCreateArea("forest "+i);
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(120), rmAreaTilesToFraction(160));
      rmSetAreaForestType(forest, "new england forest");
      rmSetAreaForestDensity(forest, 1.0);
      rmSetAreaForestClumpiness(forest, 0.9);
      rmSetAreaForestUnderbrush(forest, 0.0);
      rmSetAreaCoherence(forest, 0.4);
      rmSetAreaSmoothDistance(forest, 10);
      rmAddAreaToClass(forest, rmClassID("classForest")); 
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidAll);
      rmAddAreaConstraint(forest, avoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);
	rmAddAreaConstraint(forest, avoidStartingUnits);
	rmAddAreaConstraint(forest, avoidSocket);
      if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         failCount=0; 
   } 
 
   // Text
   rmSetStatusText("",0.70);

   // DEER
   int playerDeerID=rmCreateObjectDef("player's deer herd");
   int bonusChance=rmRandFloat(0, 1);
   
   if(bonusChance<0.25)
      rmAddObjectDefItem(playerDeerID, "deer", 6, 5.0);
   else if(bonusChance<0.5)
      rmAddObjectDefItem(playerDeerID, "deer", 7, 6.0);
   else if(bonusChance<0.75)
      rmAddObjectDefItem(playerDeerID, "deer", 8, 6.0);
   else
      rmAddObjectDefItem(playerDeerID, "deer", 9, 6.0);

   rmSetObjectDefMinDistance(playerDeerID, 15.0);
   rmSetObjectDefMaxDistance(playerDeerID, 25.0);
   rmAddObjectDefConstraint(playerDeerID, avoidDeer);
   rmAddObjectDefConstraint(playerDeerID, avoidAll);
   rmAddObjectDefConstraint(playerDeerID, avoidSocket);
   rmAddObjectDefConstraint(playerDeerID, avoidImpassableLand);
//   rmAddObjectDefConstraint(playerDeerID, avoidStartingUnits);
   rmSetObjectDefCreateHerd(playerDeerID, true);
   rmPlaceObjectDefPerPlayer(playerDeerID, false, 1);

   int deerID=rmCreateObjectDef("deer herd");
   bonusChance=rmRandFloat(0, 1);
   
   if(bonusChance<0.5)
      rmAddObjectDefItem(deerID, "deer", rmRandInt(6,8), 4.0);
   else
      rmAddObjectDefItem(deerID, "deer", rmRandInt(7,9), 6.0);

   rmSetObjectDefMinDistance(deerID, 45.0);
   rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(deerID, avoidDeer);
   rmAddObjectDefConstraint(deerID, avoidAll);
   rmAddObjectDefConstraint(deerID, avoidSocket);
   rmAddObjectDefConstraint(deerID, avoidImpassableLand);
   rmAddObjectDefConstraint(deerID, avoidStartingUnits);
   rmSetObjectDefCreateHerd(deerID, true);
   rmPlaceObjectDefPerPlayer(deerID, false, 4);

	// Text
   rmSetStatusText("",0.80);

   // SHEEP
	int playerSheepID=rmCreateObjectDef("player sheep");
	rmAddObjectDefItem(playerSheepID, "sheep", 2, 4.0);
	rmSetObjectDefMinDistance(playerSheepID, 16.0);
	rmSetObjectDefMaxDistance(playerSheepID, 32.0);
	rmAddObjectDefConstraint(playerSheepID, avoidSheep);
	rmAddObjectDefConstraint(playerSheepID, avoidAll);
	rmAddObjectDefConstraint(playerSheepID, longPlayerConstraint);
	rmAddObjectDefConstraint(playerSheepID, avoidCliffs);
	rmAddObjectDefConstraint(playerSheepID, avoidImpassableLand);
      rmPlaceObjectDefPerPlayer(playerSheepID, false, 2);

	int sheepID=rmCreateObjectDef("sheep");
	rmAddObjectDefItem(sheepID, "sheep", 2, 4.0);
	rmSetObjectDefMinDistance(sheepID, 0.0);
	rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(sheepID, avoidSheep);
	rmAddObjectDefConstraint(sheepID, avoidAll);
	rmAddObjectDefConstraint(sheepID, longPlayerConstraint);
	rmAddObjectDefConstraint(sheepID, avoidCliffs);
	rmAddObjectDefConstraint(sheepID, avoidWater10);
	rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
	rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);

   // Text
   rmSetStatusText("",0.9);
}
